您的位置:首页 > 编程语言 > Java开发

hdu1159(最长公共子序列+dp)java

2017-08-18 13:59 281 查看

Common Subsequence

[align=center]Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 40989    Accepted Submission(s): 18932
[/align]

[align=left]Problem Description[/align]
A subsequence of a given sequence is the given sequence with some elements (possible none) left out. Given a sequence X = <x1, x2, ..., xm> another sequence Z = <z1, z2, ..., zk> is a subsequence of X if there exists a strictly increasing
sequence <i1, i2, ..., ik> of indices of X such that for all j = 1,2,...,k, xij = zj. For example, Z = <a, b, f, c> is a subsequence of X = <a, b, c, f, b, c> with index sequence <1, 2, 4, 6>. Given two sequences X and Y the problem is to find the length of
the maximum-length common subsequence of X and Y.

The program input is from a text file. Each data set in the file contains two strings representing the given sequences. The sequences are separated by any number of white spaces. The input data are correct. For each set of data the program prints on the standard
output the length of the maximum-length common subsequence from the beginning of a separate line.

 

[align=left]Sample Input[/align]

abcfbc abfcab
programming contest
abcd mnp

 

[align=left]Sample Output[/align]

4
2
0

 

[align=left]Source[/align]
Southeastern Europe 2003
题意:求两个字符串的公共子串。

思路:就是通过两个字符串的每个字符互相比较,根据比较情况相同与否确定递推关系:dp [ i + 1 ] [ j + 1 ] 表示匹配到 a 字符串的第 i 个字符和 b 字符串的第 j 个字符时的最大匹配数,由于读字符串的时候我是从下标 0
读起的,但我需要用 dp [ 0 ] ,所以就都是加了一,否则也可以读入的时候直接从 a + 1 和 b + 1 读起。当匹配到 a [ i ] 与 b [ j ] 时,若相等,则 dp [ i + 1 ] [ j + 1
] = dp [ i ] [ j ] +1,即在匹配完 a [ i - 1 ] 和 b [ j - 1 ] 时的最大值再加上 1 组匹配;若不相等,
8d15
则 dp [ i + 1 ] [ j + 1 ] = max ( dp [ i + 1 ] [ j ]
, dp [ i ] [ j + 1 ] )。这样 dp 到最后就得出了结果。

代码实现:
import java.util.Scanner;

public class Main {
static int dp[][] = new int[1001][1001];

public static void main(String[] args) {
Scanner sc = new Scanner(System.in);
while (sc.hasNext()) {
String xx = sc.next();
String zz = sc.next();
int x[] = new int[xx.length() + 1];
x[0] = 0;
for (int i = 1; i <= xx.length(); i++)
x[i] = xx.charAt(i - 1);
int z[] = new int[zz.length() + 1];
z[0] = 0;
for (int i = 1; i <= zz.length(); i++)
z[i] = zz.charAt(i - 1);
int ans = 0;
for (int i = 1; i <= xx.length(); i++) {
for (int j = 1; j <= zz.length(); j++) {
if (x[i] == z[j]) {
dp[i][j] = dp[i - 1][j - 1] + 1;
} else {
dp[i][j] = Math.max(dp[i - 1][j], dp[i][j - 1]);
}
}
}
System.out.println(dp[xx.length()][zz.length()]);
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: